%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Function to assign class label for given mixed data %%%%%%%

function class_label = OCIL_Mixed_Class_assign(x_categoric, x_numeric, frequency_in_cluster, cluster_count, numeric_sum, feature_weight)

[~,d_c] = size(x_categoric);
[~,d_n] = size(x_numeric);
[~,~,k] = size(frequency_in_cluster);

%% Calculate the object-cluster similarity of categorical part
categoric_proba = zeros(d_c,k);
for i = 1:d_c
    for c = 1:k
        categoric_proba(i,c) = frequency_in_cluster(i, x_categoric(i), c)/cluster_count(c);
    end
end

%% Calculate the object-cluster similarity of numerical part
average_numeric = zeros(k, d_n);
for i = 1:k
    average_numeric(i, :) = numeric_sum(i, :)./cluster_count(i);
end
numeric_proba = zeros(1, k);
for i = 1:k
    differen = x_numeric - average_numeric(i, :);
    numeric_proba(i) = exp(-0.5*(differen*differen'));
end
numeric_proba = numeric_proba./sum(numeric_proba);

%% Object-cluster similarity and cluster assignment
attribute_proba = [categoric_proba; numeric_proba];
class_proba = (attribute_proba')*(feature_weight');
[~, class_label] = max(class_proba);